#include "scene.h"

Render() {

	for (int tmi = 0; tmi < tmeshesN; tmi++) {
		for (int vi = 0; vi < tmeshes[tmi].vertsN; vi++) {
			if (!shader)
				vp = ppc.Project(verts[vi]);
			else
				vp = VertexShader(verts[vi]);
		}
		for (int tri = 0; tri < tmeshes[tmi].trisN; tri++) {
			ComputeAABB();
			ClipAABB();
			SetupEdgeEquations();
			SetupRasterizationParameterInterpolation();
			for (v = top to bottom) {
				for (u = left to right) {
					if (pixel(u, v) outside projected triangle)
						continue;
					z = InterpolateCurrentDepth(u, v);
					if (z is farther)
						continue;
					if (!shader) {
						Image(u, v) = InterpolateColor(u, v);
						Image(u, v) = TextureMap(u, v);
					}
					else {
						// GPU PROGRAMMABILITY
						FragmentShader(Interpolate Rasterization Parameters);
					}
				}
			}
		}
	}

}